# Gtk::RecentManager Class Reference
[RecentFiles]

RecentManager provides a facility for adding, removing and looking up recently used files. More...

Inherits Glib::Object.

Collaboration diagram for Gtk::RecentManager:

[legend]

List of all members.

## Classes

class | Data
| Meta-data passed to add_item(). More...

## Public Types

typedef Glib::ListHandle < RecentInfo, RecentInfoTraits > | ListHandle_RecentInfos
typedef sigc::slot< void > | SlotChanged
| For instance, void on_changed();.

## Public Member Functions

virtual | ~RecentManager ()
GtkRecentManager* | gobj ()
| Provides access to the underlying C GObject.
const GtkRecentManager* | gobj () const
| Provides access to the underlying C GObject.
GtkRecentManager* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
void | set_screen (const Glib::RefPtr< Gdk::Screen >& screen)
| Sets the screen for a recent manager; the screen is used to track the user's currently configured recently used documents storage.
bool | add_item (const Glib::ustring& uri)
| Adds a new resource into the recently used resources list.
bool | add_item (const Glib::ustring& uri, const Data& recent_data)
| Adds a new resource into the recently used resources list, taking meta data from the given Data instead of guessing it from the URI.
bool | remove_item (const Glib::ustring& uri)
| Removes a resource pointed by uri from the recently used resources list handled by a recent manager.
Glib::RefPtr< RecentInfo > | lookup_item (const Glib::ustring& uri)
| Searches for a URI inside the recently used resources list, and Return value: a Gtk::RecentInfo structure containing information.
Glib::RefPtr< const RecentInfo > | lookup_item (const Glib::ustring& uri) const
| Searches for a URI inside the recently used resources list, and Return value: a Gtk::RecentInfo structure containing information.
bool | has_item (const Glib::ustring& uri) const
| Checks whether there is a recently used resource registered with uri inside the recent manager.
bool | move_item (const Glib::ustring& uri, const Glib::ustring& new_uri)
| Changes the location of a recently used resource from uri to new_uri.
void | set_limit (int limit)
| Sets the maximum number of item that the get_items() function should return.
int | get_limit () const
| Gets the maximum number of items that the get_items() function should return.
ListHandle_RecentInfos | get_items () const
| Gets the list of recently used resources.
int | purge_items ()
| Purges every item from the recently used resources list.
Glib::SignalProxy0< void > | signal_changed ()
| The "changed" signal is emitted when an item in the recently used resources list is changed.
Glib::PropertyProxy_ReadOnly < Glib::ustring > | property_filename () const
| The full path to the file to be used to store and read the list.
Glib::PropertyProxy< int > | property_limit ()
| The maximum number of items to be returned by gtk_recent_manager_get_items().
Glib::PropertyProxy_ReadOnly< int > | property_limit () const
| The maximum number of items to be returned by gtk_recent_manager_get_items().
Glib::PropertyProxy_ReadOnly< int > | property_size () const
| The size of the recently used resources list.

## Static Public Member Functions

static Glib::RefPtr < RecentManager > | create ()
static Glib::RefPtr < RecentManager > | get_default ()
| Gets a unique instance of Gtk::RecentManager, that you can share in your application without caring about memory management.
static Glib::RefPtr < RecentManager > | get_for_screen (const Glib::RefPtr< Gdk::Screen >& screen)
| Gets the recent manager object associated with screen; if this function has not previously been called for the given screen, a new recent manager object will be created and associated with the screen.

## Protected Member Functions

| RecentManager ()
virtual void | on_changed ()

## Related Functions

(Note that these are not member functions.)
Glib::RefPtr< Gtk::RecentManager > | wrap (GtkRecentManager* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

RecentManager provides a facility for adding, removing and looking up recently used files.

Each recently used file is identified by its URI, and has meta-data associated to it, like the names and command lines of the applications that have registered it, the number of time each application has registered the same file, the mime type of the file and whether the file should be displayed only by the applications that have registered it.

The RecentManager acts like a database of all the recently used files. You can create new RecentManager objects, but it is more efficient to use the standard recent manager for the Gdk::Screen so that informations about the recently used files is shared with other people using them. Normally, you retrieve the recent manager for a particular screen using get_for_screen() and it will contain information about current recent manager for that screen.

Since gtkmm 2.10:

## Member Typedef Documentation

typedef Glib::ListHandle<RecentInfo, RecentInfoTraits> Gtk::RecentManager::ListHandle_RecentInfos

typedef sigc::slot<void> Gtk::RecentManager::SlotChanged

For instance, void on_changed();.

## Constructor & Destructor Documentation

virtual Gtk::RecentManager::~RecentManager | ( |  | ) | `[virtual]`

Gtk::RecentManager::RecentManager | ( |  | ) | `[protected]`

## Member Function Documentation

bool Gtk::RecentManager::add_item | ( | const Glib::ustring & | uri,
|  | const Data& | recent_data |
| ) |  |  |

Adds a new resource into the recently used resources list, taking meta data from the given Data instead of guessing it from the URI.

bool Gtk::RecentManager::add_item | ( | const Glib::ustring & | uri | ) |

Adds a new resource into the recently used resources list.

This function will try and guess some of the meta-data associated to a URI. If you know some of meta-data about the document yourself, set the desired fields of a RecentManager::Data structure and pass it to add_item(). Adds a new resource, pointed by uri, into the recently used resources list.

This function automatically retrieves some of the needed metadata and setting other metadata to common default values; it then feeds the data to add_full().

See add_full() if you want to explicitly define the metadata for the resource pointed by uri.

Parameters:

  | uri | A valid URI.

Returns:
  `true` if the new item was successfully added to the recently used resources list

Since gtkmm 2.10:

static Glib::RefPtr<RecentManager> Gtk::RecentManager::create | ( |  | ) | `[static]`

static Glib::RefPtr<RecentManager> Gtk::RecentManager::get_default | ( |  | ) | `[static]`

Gets a unique instance of Gtk::RecentManager, that you can share in your application without caring about memory management.

The returned instance will be freed when you application terminates.

Returns:
  A unique Gtk::RecentManager. Do not ref or unref it.

Since gtkmm 2.10:

static Glib::RefPtr<RecentManager> Gtk::RecentManager::get_for_screen | ( | const Glib::RefPtr< Gdk::Screen >& | screen | ) | `[static]`

Gets the recent manager object associated with screen; if this function has not previously been called for the given screen, a new recent manager object will be created and associated with the screen.

Recent manager objects are fairly expensive to create, so using this function is usually a better choice than calling new() and setting the screen yourself; by using this function a single recent manager object will be shared between users.

Parameters:

  | screen | A Gdk::Screen.

Returns:
  A unique Gtk::RecentManager associated with the given screen. This recent manager is associated to the with the screen and can be used as long as the screen is open. Do not ref or unref it.

Deprecated: 2.12: This function has been deprecated and should not be used in newly written code. Calling this function is equivalent to calling get_default().

Since gtkmm 2.10:

ListHandle_RecentInfos Gtk::RecentManager::get_items | ( |  | ) | const

Gets the list of recently used resources.

Returns:
  A list of newly allocated Gtk::RecentInfo objects. Use Gtk::RecentInfo::unref() on each item inside the list, and then free the list itself using Glib::list_free().

Since gtkmm 2.10:

int Gtk::RecentManager::get_limit | ( |  | ) | const

Gets the maximum number of items that the get_items() function should return.

Returns:
  The number of items to return, or -1 for every item.

Since gtkmm 2.10:

const GtkRecentManager* Gtk::RecentManager::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::ObjectBase.

GtkRecentManager* Gtk::RecentManager::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::ObjectBase.

GtkRecentManager* Gtk::RecentManager::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

bool Gtk::RecentManager::has_item | ( | const Glib::ustring & | uri | ) | const

Checks whether there is a recently used resource registered with uri inside the recent manager.

Parameters:

  | uri | A URI.

Returns:
  `true` if the resource was found, `false` otherwise.

Since gtkmm 2.10:

Glib::RefPtr<const RecentInfo> Gtk::RecentManager::lookup_item | ( | const Glib::ustring & | uri | ) | const

Searches for a URI inside the recently used resources list, and Return value: a Gtk::RecentInfo structure containing information.

Parameters:

  | uri | A URI.

Returns:
  A Gtk::RecentInfo structure containing information about the resource pointed by uri, or `0` if the URI was not registered in the recently used resources list. Free with Gtk::RecentInfo::unref().

Since gtkmm 2.10:

Glib::RefPtr<RecentInfo> Gtk::RecentManager::lookup_item | ( | const Glib::ustring & | uri | ) |

Searches for a URI inside the recently used resources list, and Return value: a Gtk::RecentInfo structure containing information.

Parameters:

  | uri | A URI.

Returns:
  A Gtk::RecentInfo structure containing information about the resource pointed by uri, or `0` if the URI was not registered in the recently used resources list. Free with Gtk::RecentInfo::unref().

Since gtkmm 2.10:

bool Gtk::RecentManager::move_item | ( | const Glib::ustring & | uri,
|  | const Glib::ustring & | new_uri |
| ) |  |  |

Changes the location of a recently used resource from uri to new_uri.

Please note that this function will not affect the resource pointed by the URIs, but only the URI used in the recently used resources list.

Parameters:

  | uri | The URI of a recently used resource.
  | new_uri | The new URI of the recently used resource, or `0` to remove the item pointed by uri in the list.

Returns:
  `true` on success.

Since gtkmm 2.10:

virtual void Gtk::RecentManager::on_changed | ( |  | ) | `[protected, virtual]`

Glib::PropertyProxy_ReadOnly<Glib::ustring> Gtk::RecentManager::property_filename | ( |  | ) | const

The full path to the file to be used to store and read the list.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<int> Gtk::RecentManager::property_limit | ( |  | ) | const

The maximum number of items to be returned by gtk_recent_manager_get_items().

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<int> Gtk::RecentManager::property_limit | ( |  | ) |

The maximum number of items to be returned by gtk_recent_manager_get_items().

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<int> Gtk::RecentManager::property_size | ( |  | ) | const

The size of the recently used resources list.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

int Gtk::RecentManager::purge_items | ( |  | ) |

Purges every item from the recently used resources list.

Returns:
  The number of items that have been removed from the recently used resources list.

Since gtkmm 2.10:

bool Gtk::RecentManager::remove_item | ( | const Glib::ustring & | uri | ) |

Removes a resource pointed by uri from the recently used resources list handled by a recent manager.

Parameters:

  | uri | The URI of the item you wish to remove.

Returns:
  `true` if the item pointed by uri has been successfully removed by the recently used resources list, and `false` otherwise.

Since gtkmm 2.10:

void Gtk::RecentManager::set_limit | ( | int | limit | ) |

Sets the maximum number of item that the get_items() function should return.

If limit is set to -1, then return all the items.

Since gtkmm 2.10:

Parameters:

  | limit | The maximum number of items to return, or -1.

void Gtk::RecentManager::set_screen | ( | const Glib::RefPtr< Gdk::Screen >& | screen | ) |

Sets the screen for a recent manager; the screen is used to track the user's currently configured recently used documents storage.

Since gtkmm 2.10:

Deprecated: 2.12: This function has been deprecated and should not be used in newly written code. Calling this function has no effect.

Parameters:

  | screen | A Gdk::Screen.

Glib::SignalProxy0< void > Gtk::RecentManager::signal_changed | ( |  | ) |

The "changed" signal is emitted when an item in the recently used resources list is changed.

Prototype:
  `void on_my_changed()`

## Friends And Related Function Documentation

Glib::RefPtr< Gtk::RecentManager > wrap | ( | GtkRecentManager * | object,
|  | bool | take_copy = `false` |
| ) |  |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  | object | The C instance.
  | take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- gtkmm/recentmanager.h